//+------------------------------------------------------------------+
//|                                                    FFS_Cross.mq4 |   
//|                                            Release date 20070127 |                                  
//+------------------------------------------------------------------+
#property copyright "icm63 (user name at Forex-TSD)"
#property link      "Forex-TSD"

/* 

READ ME FIRST..
I have nothing to do with www.forexforsmarties.com. 
You use these tools at YOUR OWN RISK.
I do not endorse or sell FFS methods or products in any way.
These tools are provided FREE of charge, I wish to promote the development of MT4 tools and minds
of those who trade FFS to get the best 'How to FFS tools'. So we all can trade FFS thru easy
and tough times. As the Forex market gives and takes away fortunes ! To make 5% monthly 
compounding over 10 years is not easy when the forex beast changes. 

Use with 
FFS_Trend
FFS_Correlation
FFS_Cross
FFS_NetPipChange

IMPORTANT : Make sure the 'IndexType' is the same within each MT4 tool.
The FFS_Mode should be set as BUY, to mirror the FFS Calcutator.


Like the FFS_Correlation tool, this is a fundamental watch. It shows the combined trend of
all the crosses related to the hedge pair in question. All cross have been adjusted to be on
the same price scale and treated as equal weight.

When this start getting wild so will the accounts trading FFS, and settings will have to be
adjusted for survival. Use the FFS_Trainspotter (in FFS_Trend) to see FFS_NetPipChange summary
to view the extremes of the net pip swings of the hedge pairs.


This is the index selection format
1. EUR/USD, USD/CHF
2. EUR/USD, USD/CHF, GBP/USD
3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
4. EUR/USD, USD/CHF, USD/JPY
5. EUR/USD, GBP/USD, USD/JPY
6. USD/CHF, GBP/USD
7. USD/CHF, GBP/USD, USD/JPY
8. GBP/USD, USD/JPY
*/

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Lime


//User Inputs Parameters
extern int IndexType = 3; // FFS Index see above
//---- variables
int NoBars = 1000;
double normcross1[];
double cross1[];

int init()
  {
  
   switch(IndexType)
    {
    case 1:
          IndicatorShortName("FFS_Cross [Index = " + IndexType+"]: EURCHF");   
          //1. EUR/USD, USD/CHF"                
          break;
    case 2:
          IndicatorShortName("FFS_Cross [Index = " + IndexType+"]: EURCHF,GBPCHF,EURGBP");
          //2. EUR/USD, USD/CHF, GBP/USD
          break;
    case 3:
          IndicatorShortName("FFS_Cross [Index " + IndexType+"]: EURCHF,GBPCHF,EURGBP,EURJPY,GBPJPY,CHFJPY");
          //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
          break;
    case 4:
          IndicatorShortName("FFS_Cross [Index = " + IndexType+"]: EURCHF,EURJPY,CHFJPY");
          //4. EUR/USD, USD/CHF, USD/JPY 
          break;
    case 5:
          IndicatorShortName("FFS_Cross [Index = " + IndexType+"]: EURJPY,GBPJPY,EURGBP"); 
          break;
    case 6:
          IndicatorShortName("FFS_Cross [Index = " + IndexType+"]: GBPCHF");
          //6. USD/CHF, GBP/USD
          break;
    case 7:
          IndicatorShortName("FFS_Cross [Index = " + IndexType+"]: GBPCHF,GBPJPY,CHFJPY");
          //7. USD/CHF, GBP/USD, USD/JPY
          break;  
    case 8:
          IndicatorShortName("FFS_Cross [Index = " + IndexType+"]: GBPJPY ");
          //8. GBP/USD, USD/JPY
          break;
    default:
          IndicatorShortName("FFS_Cross Index: EURCHF,GBPCHF,EURGBP,EURJPY,GBPJPY,CHFJPY");
          //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
          break;
   }
   
   IndicatorBuffers(2);
   SetIndexDrawBegin(0,5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,normcross1);
   SetIndexLabel(0, "Cross");
   SetIndexBuffer(1,cross1);
   return(0);
  }
  
int deinit()
  {   
   return(0);
  }
int start()
  {      
 
     int limit;
     int counted_bars=IndicatorCounted();
     double EURCHFW, GBPCHFW, EURJPYW, GBPJPYW, CHFJPYW, EURGBPW;
      if ( counted_bars > 0 )  limit=Bars-counted_bars;
      if ( counted_bars < 0 )  return(0);
      if ( counted_bars ==0 )  limit=Bars-1; 
      
      //Determine correct weight to get all prices on scale of 10,000
      EURCHFW = (10000/(iClose("EURCHF",0,1)*10000))*10000;
      GBPCHFW = (10000/(iClose("GBPCHF",0,1)*10000))*10000;
      EURJPYW = (10000/(iClose("EURJPY",0,1)*10000))*10000;
      GBPJPYW = (10000/(iClose("GBPJPY",0,1)*10000))*10000;
      
      CHFJPYW = (10000/(iClose("CHFJPY",0,1)*10000))*10000;
      EURGBPW = (10000/(iClose("EURGBP",0,1)*10000))*10000;
      //Print("EURCHFW :" + EURCHFW+ "  Price : " +iClose("EURCHF",0,1));
       
     for(int i=limit; i>=0; i--)
       {
            switch(IndexType)
               {
               case 1:
                     //1. EUR/USD, USD/CHF"
                     cross1[i]=  iClose("EURCHF",0,i) * EURCHFW;                    
                     break;
               case 2:
                     //2. EUR/USD, USD/CHF, GBP/USD
                     cross1[i]=  iClose("EURCHF",0,i) * EURCHFW + iClose("GBPCHF",0,i) * GBPCHFW 
                     + iClose("EURGBP",0,i)  * EURGBPW;
                     break;
               case 3:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     cross1[i]=  iClose("EURCHF",0,i) * EURCHFW + iClose("GBPCHF",0,i)  * GBPCHFW 
                     + iClose("EURJPY",0,i)  * EURJPYW + iClose("GBPJPY",0,i)  * GBPJPYW 
                     + iClose("CHFJPY",0,i)  * CHFJPYW + iClose("EURGBP",0,i)  * EURGBPW ;
                     break;
               case 4:
                     //4. EUR/USD, USD/CHF, USD/JPY 
                     cross1[i]=  iClose("EURCHF",0,i) * EURCHFW + iClose("EURJPY",0,i)  * EURJPYW 
                     + iClose("CHFJPY",0,i)  * CHFJPYW ;
                     break;
               case 5:
                     //5. EUR/USD, GBP/USD, USD/JPY
                     cross1[i]= iClose("EURJPY",0,i)  * EURJPYW + iClose("GBPJPY",0,i)  * GBPJPYW 
                     + iClose("EURGBP",0,i)  * EURGBPW  ;    
                     break;
               case 6:
                     //6. USD/CHF, GBP/USD
                     cross1[i]= iClose("GBPCHF",0,i)  * GBPCHFW ;
                     break;
               case 7:
                     //7. USD/CHF, GBP/USD, USD/JPY
                     cross1[i]=   iClose("GBPCHF",0,i)  * GBPCHFW + iClose("GBPJPY",0,i)  * GBPJPYW 
                     + iClose("CHFJPY",0,i)  * CHFJPYW  ;
                     break;  
               case 8:
                     //8. GBP/USD, USD/JPY 
                     cross1[i]= iClose("GBPJPY",0,i)  * GBPJPYW ;
                     break;
               default:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     cross1[i]=  iClose("EURCHF",0,i) * EURCHFW + iClose("GBPCHF",0,i)  * GBPCHFW 
                     + iClose("EURJPY",0,i)  * EURJPYW + iClose("GBPJPY",0,i)  * GBPJPYW 
                     + iClose("CHFJPY",0,i)  * CHFJPYW + iClose("EURGBP",0,i)  * EURGBPW ;
                     break;
              }
       
               double Maxcross1=-10000000, Mincross1=10000000;
       
                 for ( int k=0; k<NoBars-1;k++)
                 {
                 if( cross1[i+k] > Maxcross1) Maxcross1 = cross1[i+k];
                 if( cross1[i+k] < Mincross1) Mincross1 = cross1[i+k];
                 } 
         
       }
       //Normalise Data btw 0 and 100
       for(int m=limit; m>=0; m--)
       {
         if (Maxcross1 - Mincross1 != 0) normcross1[m] = 100*(cross1[m]-Mincross1)/(Maxcross1-Mincross1);  
       }
       
    return(0);
  }
//+------------------------------------------------------------------+