//+------------------------------------------------------------------+
//|                                                    FFS_Trend.mq4 |
//|                                            Release date 20070127 |
//|                           Fixed by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "icm63 (user name at Forex-TSD)"
#property link      "Forex-TSD"

/* 
READ ME FIRST..
I have nothing to do with www.forexforsmarties.com. 
You use these tools at YOUR OWN RISK.
I do not endorse or sell FFS methods or products in any way.
These tools are provided FREE of charge, I wish to promote the development of MT4 tools and minds
of those who trade FFS to get the best 'How to FFS tools'. So we all can trade FFS thru easy
and tough times. As the Forex market gives and takes away fortunes ! To make 5% monthly 
compounding over 10 years is not easy when the forex beast changes. 

Use with 
FFS_Trend
FFS_Correlation
FFS_Cross
FFS_NetPipChange

IMPORTANT : Make sure the 'IndexType' is the same within each MT4 tool.
The FFS_Mode should be set as BUY, to mirror the FFS Calcutator.

This is FFS_Trend and FFS_Trainspotter. As much info as I could stick in.
Places comments in the main chart, and trend of the USD positive and 
negative combinations in a indicator window.

The USD trend has normalised ( ie 0 to 100 scale) data so all pairs price
 index are the same.

How to use : Place indicator into any chart, say EURUSD. Then in properties
make the EURUSD chart a line chart, then make the line chart the same color 
as your background...there it is out of the way !

These calculations assume an equal weight between all the pairs in the 
FFS hedge combination. That each pair pip value is, at best it can be, to be
of the same value.
Example...
EURUSD pip value 100k lots is $10.00
USDCHF pip value 100k lost is $7.97 ( 1/1.2532 * 10 , as at 20070127)
so 1.25 lot must be trades to equal the EURUSD $10 pip value.

This is the index selection format
1. EUR/USD, USD/CHF
2. EUR/USD, USD/CHF, GBP/USD
3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
4. EUR/USD, USD/CHF, USD/JPY
5. EUR/USD, GBP/USD, USD/JPY
6. USD/CHF, GBP/USD
7. USD/CHF, GBP/USD, USD/JPY
8. GBP/USD, USD/JPY


*/

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow

//User Inputs Parameters
extern int IndexType = 3;// FFS Index see above
extern int USDneg_Inverse = 0; // Inverse the USD Negative pairs combination
extern int NetPip_RPeriod = 2; // Daily change period  for FFS_NetPipChange summary
extern string FFS_Mode = "BUY";//FFS mode to enter hedge from FFS calculator
extern int NoBars = 780;// 1 years trading days, just makes the chart look nice !

//---- variables
double normUSDpos[];
double normUSDneg[];
double USDpos[];
double USDneg[];
string DD;
int D100, D200, D300, D400, D500, D600, D700, D800, D900, D1000;
int S100, S200, S300, S400, S500, S600, S700, S800, S900, S1000;
int R100, R200, R300, R400, R500, R600, R700, R800, R900, R1000;
double D000, DMAX=1, SMAX=1, RMAX=1;
string DMAX_Date, SMAX_Date, RMAX_Date;

int init()
  {
   IndicatorShortName("FFS_Trend USD_Positive: YELLOW USD_Negative: RED [Index "+ IndexType +"]");
   IndicatorBuffers(4);
   SetIndexDrawBegin(0,5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,normUSDpos);
   SetIndexLabel(0, "USDpos");
   SetIndexDrawBegin(1,5); 
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,normUSDneg);
   SetIndexLabel(1, "USDneg");  
   SetIndexBuffer(2,USDpos);
   SetIndexBuffer(3,USDneg);
   
   return(0);
  }

//FUNCTIONS
  //Comments to Main Cart on FFS Index types and long swap.
  void MyComments(int Index)
  {
    string Selection, Pos, Neg;
    string Nature;
    double NS1, NS2, NS3, NS4, NS5, NS6, NS7, NS8;
    double MS1, MS2, MS3, MS4, MS5, MS6, MS7, MS8;
    int S1, S2, S3, S4, S5, S6, S7, S8;
    
    NS1 = MarketInfo("EURUSD",MODE_SWAPLONG)+ MarketInfo("USDCHF",MODE_SWAPLONG);
    NS2 = MarketInfo("EURUSD",MODE_SWAPLONG)+ MarketInfo("USDCHF",MODE_SWAPLONG) 
    + MarketInfo("GBPUSD",MODE_SWAPLONG);
    NS3 = MarketInfo("EURUSD",MODE_SWAPLONG)+ MarketInfo("USDCHF",MODE_SWAPLONG) 
    + MarketInfo("GBPUSD",MODE_SWAPLONG)+ MarketInfo("USDJPY",MODE_SWAPLONG);
    NS4 = MarketInfo("EURUSD",MODE_SWAPLONG)+ MarketInfo("USDCHF",MODE_SWAPLONG) 
    + MarketInfo("USDJPY",MODE_SWAPLONG);
    NS5 = MarketInfo("EURUSD",MODE_SWAPLONG)+ MarketInfo("GBPUSD",MODE_SWAPLONG) 
    + MarketInfo("USDJPY",MODE_SWAPLONG);
    NS6 = MarketInfo("USDCHF",MODE_SWAPLONG)+ MarketInfo("GBPUSD",MODE_SWAPLONG);
    NS7 = MarketInfo("USDCHF",MODE_SWAPLONG)+ MarketInfo("GBPUSD",MODE_SWAPLONG) 
    + MarketInfo("USDJPY",MODE_SWAPLONG);
    NS8 = MarketInfo("GBPUSD",MODE_SWAPLONG)+ MarketInfo("USDJPY",MODE_SWAPLONG);
    
    
    MS1 = MarketInfo("EURUSD",MODE_SWAPSHORT)+ MarketInfo("USDCHF",MODE_SWAPSHORT);
    MS2 = MarketInfo("EURUSD",MODE_SWAPSHORT)+ MarketInfo("USDCHF",MODE_SWAPSHORT) 
    + MarketInfo("GBPUSD",MODE_SWAPSHORT);
    MS3 = MarketInfo("EURUSD",MODE_SWAPSHORT)+ MarketInfo("USDCHF",MODE_SWAPSHORT) 
    + MarketInfo("GBPUSD",MODE_SWAPSHORT)+ MarketInfo("USDJPY",MODE_SWAPSHORT);
    MS4 = MarketInfo("EURUSD",MODE_SWAPSHORT)+ MarketInfo("USDCHF",MODE_SWAPSHORT) 
    + MarketInfo("USDJPY",MODE_SWAPSHORT);
    MS5 = MarketInfo("EURUSD",MODE_SWAPSHORT)+ MarketInfo("GBPUSD",MODE_SWAPSHORT) 
    + MarketInfo("USDJPY",MODE_SWAPSHORT);
    MS6 = MarketInfo("USDCHF",MODE_SWAPSHORT)+ MarketInfo("GBPUSD",MODE_SWAPSHORT);
    MS7 = MarketInfo("USDCHF",MODE_SWAPSHORT)+ MarketInfo("GBPUSD",MODE_SWAPSHORT) 
    + MarketInfo("USDJPY",MODE_SWAPSHORT);
    MS8 = MarketInfo("GBPUSD",MODE_SWAPSHORT)+ MarketInfo("USDJPY",MODE_SWAPSHORT);
    
    S1 = MarketInfo("EURUSD",MODE_SPREAD) + MarketInfo("USDCHF",MODE_SPREAD);
    S2 = MarketInfo("EURUSD",MODE_SPREAD)+ MarketInfo("USDCHF",MODE_SPREAD) 
    + MarketInfo("GBPUSD",MODE_SPREAD);
    S3 = MarketInfo("EURUSD",MODE_SPREAD)+ MarketInfo("USDCHF",MODE_SPREAD) 
    + MarketInfo("GBPUSD",MODE_SPREAD) + MarketInfo("USDJPY",MODE_SPREAD);
    S4 = MarketInfo("EURUSD",MODE_SPREAD)+ MarketInfo("USDCHF",MODE_SPREAD) 
    + MarketInfo("USDJPY",MODE_SPREAD);
    S5 = MarketInfo("EURUSD",MODE_SPREAD) + MarketInfo("GBPUSD",MODE_SPREAD) 
    + MarketInfo("USDJPY",MODE_SPREAD);
    S6 = MarketInfo("GBPUSD",MODE_SPREAD) + MarketInfo("USDCHF",MODE_SPREAD);
    S7 = MarketInfo("GBPUSD",MODE_SPREAD) + MarketInfo("USDCHF",MODE_SPREAD) 
    + MarketInfo("USDJPY",MODE_SPREAD);
    S8 = MarketInfo("GBPUSD",MODE_SPREAD) + MarketInfo("USDJPY",MODE_SPREAD);
    
     switch(Index)
      {
      case 1:
            Selection = "1";
            Pos = "USDCHF";
            Neg = "EURUSD";
            Nature = "Closest negative correlation, best hedge, lowest rewards.";
            break;
      case 2:
            Selection = "2";
            Pos = "USDCHF";
            Neg = "EURUSD, GBPUSD";
            Nature = "GBP adds some volatility, low interest";
            break;
      case 3:
            Selection = "3";
            Pos = "USDCHF, USDJPY";
            Neg = "EURUSD, GBPUSD";
            Nature = "JPY adds more volatility, pays more interest.";
            break;
      case 4:
            Selection = "4";
            Pos = "USDCHF, USDJPY";
            Neg = "EURUSD";
            Nature = "Removes the (low) interest cost of the GBP.";
            break;
      case 5:
            Selection = "5";
            Pos = "USDJPY";
            Neg = "EURUSD, GBPUSD";
            Nature = "More volatility without the CHF, low interest.";
            break;
      case 6:
            Selection = "6";
            Pos = "USDCHF";
            Neg = "GBPUSD";
            Nature = "Removes the (high) interest cost of the EUR.";
            break;
      case 7:
            Selection = "7";
            Pos = "USDJPY";
            Neg = "EURUSD, GBPUSD";
            Nature = "More volatile without the EUR, pays most interest.";
            break;
      case 8:
            Selection = "8";
            Pos = "USDJPY";
            Neg = "GBPUSD";
            Nature = "Most volatile. Valium recommended.";
            break;
      default:
            Selection = "3. EURUSD, USDCHF, GBPUSD, USDJPY";
            Pos = "USDCHF, USDJPY";
            Neg = "EURUSD, GBPUSD";
            Nature = "JPY adds more volatility, pays most interest.";
            break;
     }
         
       Drawdown(Index);
       
       Comment(
       "FFS Trainspotter ! \n"+
       "FFS Mode : " + FFS_Mode + " \n"+
       "FFS Index selected : [" + Selection + "]   Description: " + Nature + "\n" + 
       "FFS Positive Index : " + Pos + "   " + 
       "FFS Negative Index : " + Neg + "\n" + 
       "FFS Account Leverage : 1:", AccountLeverage()+ "\n" + 
       " \n"+
       "FFS Swap by Index (BUY) : " + " "+
         "1.. " + DoubleToStr(NS1,2) + " "+
         " 2.. " + DoubleToStr(NS2,2) + " "+
         " 3.. " + DoubleToStr(NS3,2) + " "+
         " 4.. " + DoubleToStr(NS4,2) + " "+
         " 5.. " + DoubleToStr(NS5,2) + " "+
         " 6.. " + DoubleToStr(NS6,2) + " "+
         " 7.. " + DoubleToStr(NS7,2) + " "+
         " 8.. " + DoubleToStr(NS8,2) + "\n"+
       "FFS Swap by Index (SELL) : " + " "+
         "1.. " + DoubleToStr(MS1,2) + " "+
         " 2.. " + DoubleToStr(MS2,2) + " "+
         " 3.. " + DoubleToStr(MS3,2) + " "+
         " 4.. " + DoubleToStr(MS4,2) + " "+
         " 5.. " + DoubleToStr(MS5,2) + " "+
         " 6.. " + DoubleToStr(MS6,2) + " "+
         " 7.. " + DoubleToStr(MS7,2) + " "+
         " 8.. " + DoubleToStr(MS8,2) + "\n"+
         "FFS Spread by Index: " + " "+
         "1.. " + DoubleToStr(S1,2) + " "+
         " 2.. " + DoubleToStr(S2,2) + " "+
         " 3.. " + DoubleToStr(S3,2) + " "+
         " 4.. " + DoubleToStr(S4,2) + " "+
         " 5.. " + DoubleToStr(S5,2) + " "+
         " 6.. " + DoubleToStr(S6,2) + " "+
         " 7.. " + DoubleToStr(S7,2) + " "+
         " 8.. " + DoubleToStr(S8,2)+ "\n" + 
         DD);
         
  }
  
  //Find Net Pip Drawdown Count by Index
  void Drawdown(int Index)
  {
  
   int limit;
   double EUR1, CHF1, GBP1, JPY1;
   int RES1, RES0;
   int RPeriod = NetPip_RPeriod; 
   int counted_bars = IndicatorCounted();
   limit = Bars - counted_bars - RPeriod;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-1; 

   for(int i = 0; i < limit; i++)
     {
      if( (iClose("EURUSD", 0, i) - iClose("EURUSD", 0, i + RPeriod)) >=0)
         {
           EUR1 = (iHigh("EURUSD", 0, i) - iLow("EURUSD",0,iLowest("EURUSD", 0, MODE_LOW, RPeriod, i  )))*10000; 
         }
      else
         {
           EUR1 = (iLow("EURUSD", 0, i) - iHigh("EURUSD",0,iHighest("EURUSD", 0, MODE_HIGH, RPeriod, i  )))*10000; 
         }
         
      if((iClose("GBPUSD", 0, i) - iClose("GBPUSD", 0, i + RPeriod))>=0)
         {
           GBP1 = (iHigh("GBPUSD", 0, i) - iLow("GBPUSD",0,iLowest("GBPUSD", 0, MODE_LOW, RPeriod, i  )))*10000; 
         }
      else
         {
           GBP1 = (iLow("GBPUSD", 0, i) - iHigh("GBPUSD",0,iHighest("GBPUSD", 0, MODE_HIGH, RPeriod, i  )))*10000; 
         }
         
         
     if((iClose("USDCHF", 0, i) - iClose("USDCHF", 0, i + RPeriod))>=0)
         {
           CHF1 = (iHigh("USDCHF", 0, i) - iLow("USDCHF",0,iLowest("USDCHF", 0, MODE_LOW, RPeriod, i  )))*10000; 
         }
      else
         {
           CHF1 = (iLow("USDCHF", 0, i) - iHigh("USDCHF",0,iHighest("USDCHF", 0, MODE_HIGH, RPeriod, i  )))*10000; 
         }
         
      if((iClose("USDJPY", 0, i) - iClose("USDJPY", 0, i + RPeriod))>=0)
         {
           JPY1 = (iHigh("USDJPY", 0, i) - iLow("USDJPY",0,iLowest("USDJPY", 0, MODE_LOW, RPeriod, i  )))*100; 
         }
      else
         {
           JPY1 = (iLow("USDJPY", 0, i) - iHigh("USDJPY",0,iHighest("USDJPY", 0, MODE_HIGH, RPeriod, i  )))*100; 
         }
          
       switch(IndexType)
               {
               case 1:
                     //1. EUR/USD, USD/CHF"
                     RES0 = EUR1 + CHF1;
                     break;
               case 2:
                     //2. EUR/USD, USD/CHF, GBP/USD
                     RES0 = EUR1 + CHF1 + GBP1;
                     break;
               case 3:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     RES0 = EUR1 + CHF1 + GBP1 + JPY1;
                     break;
               case 4:
                     //4. EUR/USD, USD/CHF, USD/JPY
                     RES0 = EUR1 + CHF1 + JPY1;
                     break;
               case 5:
                     //5. EUR/USD, GBP/USD, USD/JPY
                     RES0 = EUR1 + GBP1 + JPY1;
                     break;
               case 6:
                     //6. USD/CHF, GBP/USD
                     RES0 = CHF1 + GBP1;
                     break;
               case 7:
                     //7. USD/CHF, GBP/USD, USD/JPY
                     RES0= CHF1 + GBP1 + JPY1;
                     break;  
               case 8:
                     //8. GBP/USD, USD/JPY 
                     RES0= GBP1 + JPY1;
                     break;
               default:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     RES0 = EUR1 + CHF1 + GBP1 + JPY1;
                     break;   
              }  
              
              //Change modes if FFS ever has to change strategy
              if(FFS_Mode =="BUY")
              {
               RES1 = RES0;
              }
              else if(FFS_Mode == "SELL")
              {
               RES1 = -RES0;
              }
              
              
         //All Data
          D000 += 1;
         if(RES1< DMAX) 
         {
            DMAX = RES1;
            DMAX_Date = TimeToStr(Time[i],TIME_DATE);
         }
      
         if(RES1 <= -900)
         {
            D1000 += 1;
         }
         else if(RES1 <= -800)
         {
            D900 += 1;
         }   
         else if(RES1 <= -700)
         {
            D800 += 1;
         }  
         else if(RES1 <= -600)
         {
            D700 += 1;
         }
         else if(RES1 <= -500)
         {
            D600 += 1;
         }
         else if(RES1 <= -400)
         {
            D500 += 1;
         }
         else if(RES1 <= -300)
         {
            D400 += 1;
         }
         else if(RES1 <= -200)
         {
            D300 += 1;
         }
         else if(RES1 <= -100)
         {
            D200 += 1;
         }
         else if(RES1 < 0 )
         {
            D100 += 1;
         }
         
         //Last three years
         if (i < (limit - (limit-780)))
         {
            if(RES1< SMAX) 
            {
               SMAX = RES1;
               SMAX_Date = TimeToStr(Time[i],TIME_DATE);
            }
            
            if(RES1 <= -900)
            {
               S1000 += 1;
            }
            else if(RES1 <= -800)
            {
               S900 += 1;
            }   
            else if(RES1 <= -700)
            {
               S800 += 1;
            }  
            else if(RES1 <= -600)
            {
               S700 += 1;
            }
            else if(RES1 <= -500)
            {
               S600 += 1;
            }
            else if(RES1 <= -400)
            {
               S500 += 1;
            }
            else if(RES1 <= -300)
            {
               S400 += 1;
            }
            else if(RES1 <= -200)
            {
               S300 += 1;
            }
            else if(RES1 <= -100)
            {
               S200 += 1;
            }
            else if(RES1 < 0 )
            {
               S100 += 1;
            }
          
          //Last 1 years ( 5 days a week, times 52 weeks = 260 trading bars)
         if (i < (limit - (limit-260)))
         {
            if(RES1< RMAX) 
            {
               RMAX = RES1;
               RMAX_Date = TimeToStr(Time[i],TIME_DATE);
            }
            
            if(RES1 <= -900)
            {
               R1000 += 1;
            }
            else if(RES1 <= -800)
            {
               R900 += 1;
            }   
            else if(RES1 <= -700)
            {
               R800 += 1;
            }  
            else if(RES1 <= -600)
            {
               R700 += 1;
            }
            else if(RES1 <= -500)
            {
               R600 += 1;
            }
            else if(RES1 <= -400)
            {
               R500 += 1;
            }
            else if(RES1 <= -300)
            {
               R400 += 1;
            }
            else if(RES1 <= -200)
            {
               R300 += 1;
            }
            else if(RES1 <= -100)
            {
               R200 += 1;
            }
            else if(RES1 < 0 )
            {
               R100 += 1;
            } 
         }
           
            
         }
     }   
     DD=
     "  \n" +
     "FFS_NetPipChange Summary [Index "+Index+", All data years : " 
     + DoubleToStr(NormalizeDouble(D000/260,1),1) + " ]\n" +
     "Note: Daily frequency of negative net pip change between current low/high and high/low " 
     + NetPip_RPeriod + " periods ago. \n"+
     "Note: The summary is dependent on MT4 data quality. \n" +
     "               All        Last 3 yrs     Last 1 yr \n"   + 
     "000-100 .. " + D100 + "          " +S100+ "               " + R100 + "\n" +
     "101-200 .. " + D200 + "          " +S200+ "               " + R200 + "\n" +
     "201-300 .. " + D300 + "          " +S300+ "               " + R300 +  "\n" +
     "301-400 .. " + D400 + "          " +S400+ "               " + R400 +  "\n" +
     "401-500 .. " + D500 + "          " +S500+ "               " + R500 +  "\n" +
     "501-600 .. " + D600 + "          " +S600+ "               " + R600 +  "\n" +
     "601-700 .. " + D700 + "          " +S700+ "               " + R700 +  "\n" +
     "701-800 .. " + D800 + "          " +S800+ "               " + R800 +  "\n" +
     "801-900 .. " + D900 + "          " +S900+ "               " + R900 +  "\n" +
     "901+    .. " + D1000 + "          " +S1000+ "               " + R1000 +  "\n" +
     "Last 1 year max pip change " + DoubleToStr(RMAX,0) + " on " + RMAX_Date  +"\n"+
     "Last 3 year max pip change " + DoubleToStr(SMAX,0) + " on " + SMAX_Date  +"\n"+
     "All data max pip change" + DoubleToStr(DMAX,0) + " on " + DMAX_Date + "\n" +
     "Data start date : " + TimeToStr(Time[limit],TIME_DATE);
     
      return(0);
  }
  

  
int deinit()
  {   
   return(0);
  }
int start()
  {      
 
     int limit;
     int counted_bars=IndicatorCounted();
     double EURW, GBPW, CHFW, JPYW;
      if ( counted_bars > 0 )  limit=Bars-counted_bars;
      if ( counted_bars < 0 )  return(0);
      if ( counted_bars ==0 )  limit=Bars-1; 
      
      //Determine correct weight to get all prices on scale of 10,000
      EURW = (10000/(iClose("EURUSD",0,1)*10000))*10000;
      GBPW = (10000/(iClose("GBPUSD",0,1)*10000))*10000;
      CHFW = (10000/(iClose("USDCHF",0,1)*10000))*10000;
      JPYW = (100/(iClose("USDJPY",0,1)*100))*100;
      //Print("EURW :" + EURW + "  Price : " +iClose("EURUSD",0,1));
     
     for(int i=limit; i>=0; i--)
       {
            switch(IndexType)
               {
               case 1:
                     //1. EUR/USD, USD/CHF"
                     USDpos[i]=  iClose("EURUSD",0,i) * EURW;
                     USDneg[i]=  iClose("USDCHF",0,i) * CHFW;
                     break;
               case 2:
                     //2. EUR/USD, USD/CHF, GBP/USD
                     USDpos[i]=  iClose("EURUSD",0,i) * EURW + iClose("GBPUSD",0,i)  * GBPW ;
                     USDneg[i]=  iClose("USDCHF",0,i) * CHFW;
                     break;
               case 3:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose("EURUSD",0,i) * EURW + iClose("GBPUSD",0,i)  * GBPW ;
                     USDneg[i]=  iClose("USDCHF",0,i) * CHFW + iClose("USDJPY",0,i)  * JPYW ;
                     break;
               case 4:
                     //4. EUR/USD, USD/CHF, USD/JPY
                     USDpos[i]=  iClose("EURUSD",0,i) * EURW;
                     USDneg[i]=  iClose("USDCHF",0,i) * CHFW + iClose("USDJPY",0,i)  * JPYW ;
                     break;
               case 5:
                     //5. EUR/USD, GBP/USD, USD/JPY
                     USDpos[i]=   iClose("EURUSD",0,i) * EURW + iClose("GBPUSD",0,i)  * GBPW ;
                     USDneg[i]=   iClose("USDJPY",0,i) * JPYW ;
                     break;
               case 6:
                     //6. USD/CHF, GBP/USD
                     USDpos[i]=  iClose("GBPUSD",0,i) * GBPW ;
                     USDneg[i]=  iClose("USDCHF",0,i) * CHFW ;
                     break;
               case 7:
                     //7. USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose("GBPUSD",0,i) * GBPW ;
                     USDneg[i]=  iClose("USDCHF",0,i) * CHFW + iClose("USDJPY",0,i)  * JPYW ;
                     break;  
               case 8:
                     //8. GBP/USD, USD/JPY 
                     USDpos[i]=  iClose("GBPUSD",0,i) * GBPW ;
                     USDneg[i]=  iClose("USDJPY",0,i) * JPYW ;
                     break;
               default:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     USDpos[i]=  iClose("EURUSD",0,i) * EURW + iClose("GBPUSD",0,i)  * GBPW ;
                     USDneg[i]=  iClose("USDCHF",0,i) * CHFW + iClose("USDJPY",0,i)  * JPYW ;
                     break;
              }
       
               double MaxPos=-10000000, MinPos=10000000;
               double MaxNeg=-10000000, MinNeg=10000000;
       
                 for ( int k=0; k<NoBars-1;k++)
                 {
                 if( USDpos[i+k] > MaxPos) MaxPos = USDpos[i+k];
                 if( USDpos[i+k] < MinPos) MinPos = USDpos[i+k];
                 if( USDneg[i+k] > MaxNeg) MaxNeg = USDneg[i+k];
                 if( USDneg[i+k] < MinNeg) MinNeg = USDneg[i+k];
                 }
               //Print("Minpos=",MinPos," maxpos=",MaxPos);
               //Print("Maxneg=",MaxNeg," minneg=",MinNeg);
       }
       //Normalise Data btw 0 and 100
       for(int m=limit; m>=0; m--)
       {
         if (MaxPos - MinPos != 0) normUSDpos[m] = 100*(USDpos[m]-MinPos)/(MaxPos-MinPos);  
         if (USDneg_Inverse == 1) 
         {
            if (MaxNeg - MinNeg != 0) normUSDneg[m] = (100-(100*(USDneg[m]-MinNeg)/(MaxNeg-MinNeg))); 
         }
         else
         {
            if (MaxNeg - MinNeg != 0) normUSDneg[m] = 100*(USDneg[m]-MinNeg)/(MaxNeg-MinNeg); 
         }   
       }
       
    MyComments(IndexType);
    return(0);
  }
 
  
//+------------------------------------------------------------------+